000100 IDENTIFICATION DIVISION.                                         CVT00010
000200 PROGRAM-ID. CVTSAMP.                                             CVT00020
000300 ENVIRONMENT DIVISION.                                            CVT00030
000400 CONFIGURATION SECTION.                                           CVT00040
000500 SPECIAL-NAMES.                                                   CVT00050
000600     SYSOUT IS SYSPRINT.                                          CVT00060
000700 INPUT-OUTPUT SECTION.                                            CVT00070
000800 FILE-CONTROL.                                                    CVT00080
000900     SELECT PRINTOUT ASSIGN SYSPRINT.                             CVT00090
001000     SELECT FLIGHTS  ASSIGN FLIGHTS.                              CVT00100
001100 DATA DIVISION.                                                   CVT00110
001200 FILE SECTION.                                                    CVT00120
001300 FD  PRINTOUT                                                     CVT00130
001400     RECORD CONTAINS 132                                          CVT00140
001500     LABEL RECORDS STANDARD                                       CVT00150
001600     RECORDING MODE F.                                            CVT00160
001800 01  PRINT-RECORD     PIC X(132).                                 CVT00170
001900 FD  FLIGHTS                                                      CVT00180
002000     BLOCK CONTAINS 32720                                         CVT00190
002100     RECORD CONTAINS 80                                           CVT00200
002200     LABEL RECORDS STANDARD                                       CVT00210
002300     RECORDING MODE F.                                            CVT00220
002400 01  FLIGHT-RECORD PIC X(80).                                     CVT00230
002500 WORKING-STORAGE SECTION.                                         CVT00240
002600 01  WS-RECORD.                                                   CVT00250
002700     05 AIRLINE-CODE     PIC   XX.                                CVT00260
002800        88   AIRLINE-IN-SUIT VALUES 'AA', 'DL',                   CVT00270
002900                 'CO', 'NW', 'TW'.                                CVT00280
003000     05 FILLER           PIC   X.                                 CVT00290
003100     05 PROCESS-CODE     PIC   X.                                 CVT00300
003200        88   AGNCY-BOOKED VALUE 'I'.                              CVT00310
003300        88   BUSINESS    VALUE 'B'.                               CVT00320
003400        88   PERSONAL    VALUE 'P'.                               CVT00330
003500     05 FILLER           PIC   X.                                 CVT00340
003600     05 FLT-DATE.                                                 CVT00350
003700        10 FLT-DATE-DAY  PIC 99.                                  CVT00360
003800        10 FILLER        PIC   X.                                 CVT00370
003900        10 FLT-DATE-MON  PIC 99.                                  CVT00380
004000        10 FILLER        PIC   X.                                 CVT00390
004100        10 FLT-DATE-YR   PIC 99.                                  CVT00400
004200     05 FILLER           PIC   X.                                 CVT00410
004300     05 BILL-DATE.                                                CVT00420
004400        10 BILL-DATE-DAY PIC 99.                                  CVT00430
004500        10 FILLER        PIC   X.                                 CVT00440
004600        10 BILL-DATE-MON PIC 99.                                  CVT00450
004700        10 FILLER        PIC   X.                                 CVT00460
004800        10 BILL-DATE-YR  PIC 99.                                  CVT00470
004900     05 FILLER           PIC   X.                                 CVT00480
005000     05 FARE-AMT.                                                 CVT00490
005100        10 FARE-DOLLARS  PIC 9999.                                CVT00500
005200        10 DECIMAL-PT    PIC X.                                   CVT00510
005300        10 FARE-CENTS    PIC V99.                                 CVT00520
005400     05 FILLER           PIC   X.                                 CVT00530
005500     05 AIRPORT-CODES.                                            CVT00540
005600        08 DUMMY-ENTRY OCCURS 1 TO 10 TIMES                       CVT00550
005700            DEPENDING ON NDX.                                     CVT00560
005800            10 AIRPORT       PIC XXX.                             CVT00570
005900            10 FILLER        PIC X.                               CVT00580
006000     05 FILLER           PIC   X(9).                              CVT00590
006100 77  FLT-EOF-SWITCH       PIC X            VALUE '0'.             CVT00600
006200     88  FLT-EOF                           VALUE  1.              CVT00610
006300 01  DETAIL-LINE-HEADING.                                         CVT00620
006400     02  CC-HEADER        PIC X VALUE '0'.                        CVT00630
006500     02  FILLER           PIC X(10).                              CVT00640
006600     02  FILLER   PIC X(54) VALUE ' AIRLINE PURCHASE DETAIL TRANSACVT00650
006700-        'CTIONS. REPORT DATE: '.                                 CVT00660
006800     02  RPT-DATE1 PICTURE X(8).                                  CVT00670
006900 01  HEADER-LINE.                                                 CVT00680
007000     02  FILLER           PIC X(10).                              CVT00690
007100     02  FILLER   PIC X(54) VALUE ' AIRLINE PURCHASE COST ANALYSISCVT00700
007200-        ' SUMMARY. REPORT DATE: '.                               CVT00710
007300     02  RPT-DATE2 PICTURE X(8).                                  CVT00720
007400 01  PRINT-LINE.                                                  CVT00730
007500     05  FILLER           PIC X(5)         VALUE SPACE.           CVT00740
007600     05  PRT-AIRLINE-CODE PIC X(2).                               CVT00750
007700     05  FILLER           PIC X(2)         VALUE SPACE.           CVT00760
007800     05  PRT-PROCESS-CODE PIC X(1).                               CVT00770
007900     05  FILLER           PIC X(2)         VALUE SPACE.           CVT00780
008000     05  PRT-FLT-DATE     PIC X(8).                               CVT00790
008100     05  FILLER           PIC X(2)         VALUE SPACE.           CVT00800
008200     05  PRT-BILL-DATE    PIC X(8).                               CVT00810
008300     05  FILLER           PIC X(2)         VALUE SPACE.           CVT00820
008400     05  PRT-FARE         PIC Z,ZZZ.99.                           CVT00830
008500     05  FILLER           PIC X(2)         VALUE SPACE.           CVT00840
008600     05  PRT-AIRPORT-CODES PIC X(80).                             CVT00850
008700 01  UNDER-LINE.                                                  CVT00860
008800     05  FILLER           PIC X(42) VALUE SPACE.                  CVT00870
008900     05  DUMMY-ENTRY OCCURS 1 TO 10 DEPENDING ON NDX.             CVT00880
009000         10  PRT-UNDERLINES PIC XXX.                              CVT00890
009100         10  FILLER         PIC X.                                CVT00900
009200 01  FARE  PIC 9999V99 VALUE 0.                                   CVT00910
009300 77  FARE-TOTAL     PIC S99999V99  COMP-3 VALUE 0.                CVT00920
009400 01  TOTAL-LINE.                                                  CVT00930
009500     02  FILLER     PIC XXX VALUE SPACE.                          CVT00940
009600     02  FILLER     PIC X(6) VALUE 'FROM: '.                      CVT00950
009700     02  BEG-DATE   PIC X(8).                                     CVT00960
009800     02  FILLER     PIC X(5) VALUE ' TO: '.                       CVT00970
009900     02  END-DATE   PIC X(8).                                     CVT00980
010000     02  FILLER     PIC XXX  VALUE '  $'.                         CVT00990
010100     02  END-ADD    PIC ZZ,ZZZ.99.                                CVT01000
010200     02  FILLER     PIC X(20).                                    CVT01010
010300 01  FARES.                                                       CVT01020
010400     05  FARE-ACCUM PIC S99999V99  COMP-3 OCCURS 10.              CVT01030
010500 77  DE-EDITED-FARE PIC 9999V99 COMP-3 VALUE 0.                   CVT01040
010600 77  EDITED-TOTAL   PIC ZZ,ZZ9.99.                                CVT01050
010700 77  NDX    PIC S99 COMPUTATIONAL VALUE 0.                        CVT01060
010800 77  NO-SPACE  PIC X VALUE '+'.                                   CVT01070
010900 77  NEW-PAGE  PIC X VALUE '0'.                                   CVT01080
011000 01  BEG-TABLE.                                                   CVT01090
011100        10 FILLER PIC X(8) VALUE '01/01/88'.                      CVT01100
011200        10 FILLER PIC X(8) VALUE '07/01/88'.                      CVT01110
011300        10 FILLER PIC X(8) VALUE '01/01/89'.                      CVT01120
011400        10 FILLER PIC X(8) VALUE '07/01/89'.                      CVT01130
011500        10 FILLER PIC X(8) VALUE '01/01/90'.                      CVT01140
011600        10 FILLER PIC X(8) VALUE '07/01/90'.                      CVT01150
011700        10 FILLER PIC X(8) VALUE '01/01/91'.                      CVT01160
011800        10 FILLER PIC X(8) VALUE '07/01/91'.                      CVT01170
011900        10 FILLER PIC X(8) VALUE '01/01/92'.                      CVT01180
012000        10 FILLER PIC X(8) VALUE '07/01/92'.                      CVT01190
012100 01  BEG-DATES REDEFINES BEG-TABLE.                               CVT01200
012200     05 BEG-PERIOD PIC X(8) OCCURS 10.                            CVT01210
012300 01  END-TABLE.                                                   CVT01220
012400        10 FILLER PIC X(8) VALUE '06/30/88'.                      CVT01230
012500        10 FILLER PIC X(8) VALUE '12/31/88'.                      CVT01240
012600        10 FILLER PIC X(8) VALUE '06/01/89'.                      CVT01250
012700        10 FILLER PIC X(8) VALUE '12/31/89'.                      CVT01260
012800        10 FILLER PIC X(8) VALUE '06/30/90'.                      CVT01270
012900        10 FILLER PIC X(8) VALUE '12/31/90'.                      CVT01280
013000        10 FILLER PIC X(8) VALUE '06/01/91'.                      CVT01290
013100        10 FILLER PIC X(8) VALUE '12/31/91'.                      CVT01300
013200        10 FILLER PIC X(8) VALUE '06/30/92'.                      CVT01310
013300        10 FILLER PIC X(8) VALUE '12/31/92'.                      CVT01320
013400 01  END-DATES REDEFINES END-TABLE.                               CVT01330
013500     05 END-PERIOD PIC X(8) OCCURS 10.                            CVT01340
013600 PROCEDURE DIVISION.                                              CVT01350
013700 100-PROLOG.                                                      CVT01360
013800     OPEN OUTPUT PRINTOUT                                         CVT01370
013900     OPEN INPUT FLIGHTS                                           CVT01380
014000     MOVE CURRENT-DATE TO RPT-DATE1 RPT-DATE2                     CVT01390
014100     MOVE SPACES TO PRINT-LINE                                    CVT01400
014200     PERFORM DETAIL-HEADING                                       CVT01410
014300     PERFORM ZERO-ACCUM VARYING NDX FROM 1                        CVT01420
014400                 BY 1 UNTIL NDX > THAN 9                          CVT01430
014500     PERFORM 600-READ-FLIGHTS.                                    CVT01440
014600*                                                                 CVT01450
014700     PERFORM 200-MAINLINE UNTIL FLT-EOF.                          CVT01460
014800*                                                                 CVT01470
014900     PERFORM 400-EPILOG.                                          CVT01480
015000*                                                                 CVT01490
015100 200-MAINLINE.                                                    CVT01500
015200     IF NOT AIRLINE-IN-SUIT NEXT SENTENCE ELSE                    CVT01510
015300       MOVE 0 TO DE-EDITED-FARE                                   CVT01520
015400       IF NOT AGNCY-BOOKED THEN                                   CVT01530
015500           ADD FARE-DOLLARS FARE-CENTS TO DE-EDITED-FARE          CVT01540
015600           IF   (BILL-DATE-YR = '88' AND BILL-DATE-MON < '07')    CVT01550
015700              ADD DE-EDITED-FARE TO FARE-ACCUM (1)                CVT01560
015800              ELSE                                                CVT01570
015900           IF   (BILL-DATE-YR = '88' AND BILL-DATE-MON > '06')    CVT01580
016000              ADD DE-EDITED-FARE TO FARE-ACCUM (2)                CVT01590
016100              ELSE                                                CVT01600
016200           IF   (BILL-DATE-YR = '89' AND BILL-DATE-MON < '07')    CVT01610
016300              ADD DE-EDITED-FARE TO FARE-ACCUM (3)                CVT01620
016400              ELSE                                                CVT01630
016500           IF   (BILL-DATE-YR = '89' AND BILL-DATE-MON > '06')    CVT01640
016600              ADD DE-EDITED-FARE TO FARE-ACCUM (4)                CVT01650
016700              ELSE                                                CVT01660
016800           IF   (BILL-DATE-YR = '90' AND BILL-DATE-MON < '07')    CVT01670
016900              ADD DE-EDITED-FARE TO FARE-ACCUM (5)                CVT01680
017000              ELSE                                                CVT01690
017100           IF   (BILL-DATE-YR = '90' AND BILL-DATE-MON > '06')    CVT01700
017200              ADD DE-EDITED-FARE TO FARE-ACCUM (6)                CVT01710
017300              ELSE                                                CVT01720
017400           IF   (BILL-DATE-YR = '91' AND BILL-DATE-MON < '07')    CVT01730
017500              ADD DE-EDITED-FARE TO FARE-ACCUM (7)                CVT01740
017600              ELSE                                                CVT01750
017700           IF   (BILL-DATE-YR = '91' AND BILL-DATE-MON > '06')    CVT01760
017800              ADD DE-EDITED-FARE TO FARE-ACCUM (8)                CVT01770
017900              ELSE                                                CVT01780
018000           IF   (BILL-DATE-YR = '92' AND BILL-DATE-MON < '07')    CVT01790
018100              ADD DE-EDITED-FARE TO FARE-ACCUM (9)                CVT01800
018200              ELSE NEXT SENTENCE.                                 CVT01810
018300     PERFORM 390-FORMAT-LINE.                                     CVT01820
018400     PERFORM 600-READ-FLIGHTS.                                    CVT01830
018500  390-FORMAT-LINE.                                                CVT01840
018600     MOVE 0 TO FARE                                               CVT01850
018700     MOVE 10 TO NDX                                               CVT01860
018800     MOVE AIRLINE-CODE TO PRT-AIRLINE-CODE                        CVT01870
018900     MOVE PROCESS-CODE TO PRT-PROCESS-CODE                        CVT01880
019000     MOVE FLT-DATE     TO PRT-FLT-DATE                            CVT01890
019100     MOVE BILL-DATE    TO PRT-BILL-DATE                           CVT01900
019200     ADD  FARE-DOLLARS FARE-CENTS TO FARE                         CVT01910
019300     MOVE FARE         TO PRT-FARE                                CVT01920
019400     MOVE AIRPORT-CODES TO PRT-AIRPORT-CODES                      CVT01930
019500     WRITE PRINT-RECORD FROM PRINT-LINE AFTER POSITIONING 1       CVT01940
019600     PERFORM EVAL-AIRPORT                                         CVT01950
019700*       VARYING NDX FROM 1 BY 1 UNTIL NDX > THAN 9                CVT01960
019800        VARYING NDX FROM 1 BY 1 UNTIL NDX EQUAL 10                CVT01970
019900     WRITE PRINT-RECORD FROM UNDER-LINE AFTER POSITIONING         CVT01980
020000        NO-SPACE                                                  CVT01990
020200     MOVE SPACES TO UNDER-LINE                                    CVT02000
020300     .                                                            CVT02010
020400 EVAL-AIRPORT.                                                    CVT02020
020500         IF AIRPORT (NDX)                                         CVT02030
020600           EQUAL 'DFW' OR 'ORD' OR 'ATL' OR 'STL'                 CVT02040
020700              OR 'MIA' OR 'RDU' OR 'PHX' OR 'DCA'                 CVT02050
020800                MOVE ALL '_' TO PRT-UNDERLINES (NDX).             CVT02060
020900 400-EPILOG.                                                      CVT02070
021000     WRITE PRINT-RECORD FROM HEADER-LINE AFTER POSITIONING 0      CVT02080
021100     PERFORM SUMMARY                                              CVT02090
021200          VARYING NDX FROM 1 BY 1 UNTIL NDX = 10                  CVT02100
021300     MOVE SPACES TO TOTAL-LINE                                    CVT02110
021400     MOVE FARE-TOTAL TO END-ADD                                   CVT02120
021500     WRITE PRINT-RECORD FROM TOTAL-LINE AFTER POSITIONING 2       CVT02130
021600     CLOSE PRINTOUT, FLIGHTS                                      CVT02140
021700     STOP RUN.                                                    CVT02150
021800*                                                                 CVT02160
021900 ZERO-ACCUM.                                                      CVT02170
022000     MOVE 0 TO FARE-ACCUM(NDX).                                   CVT02180
022100 DETAIL-HEADING.                                                  CVT02190
022200     WRITE PRINT-RECORD FROM DETAIL-LINE-HEADING AFTER            CVT02200
022300        POSITIONING NEW-PAGE.                                     CVT02210
022400 SUMMARY.                                                         CVT02220
022500        ADD FARE-ACCUM(NDX) TO FARE-TOTAL                         CVT02230
022600        MOVE FARE-ACCUM(NDX) TO END-ADD                           CVT02240
022700        MOVE BEG-PERIOD(NDX) TO BEG-DATE                          CVT02250
022800        MOVE END-PERIOD(NDX) TO END-DATE                          CVT02260
022900        WRITE PRINT-RECORD FROM TOTAL-LINE AFTER                  CVT02270
023000            POSITIONING 1 LINES.                                  CVT02280
023100 600-READ-FLIGHTS.                                                CVT02290
023200     READ FLIGHTS INTO FLIGHT-RECORD                              CVT02300
023300       AT END MOVE '1' TO FLT-EOF-SWITCH.                         CVT02310
023400     MOVE FLIGHT-RECORD TO WS-RECORD.                             CVT02320
023500 600-READ-FLIGHTS-EXIT.                                           CVT02330
023600*                                                                 CVT02340
